#pragma once
#include "afxwin.h"
#include "resource.h"
#include "zTcpSock.h"
#include <afxmt.h> // for threadsafe critical sections (mainly process messages)


// CChatDlg dialog

class CChatDlg : public CDialog
{
	DECLARE_DYNAMIC(CChatDlg)

public:
	CChatDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CChatDlg();

// Dialog Data
	enum { IDD = IDD_CHAT_DIALOG };

	void ShowWnd();
	void HideWnd();
	bool IsShown();

	void AddRecvText(const char* lpText);

	// client stuff
	CzTcpSock m_CliSock;

	// server stuff
	CzTcpSock m_ListenSock;
	CObArray m_PeerList;

	void OnConnect(LPVOID hSock);
	void OnAccept(LPVOID hSock);
	void OnRecv(LPVOID hSock);
	void OnClose(LPVOID hSock);

	void FormatControls();

	void CloseAll();
	void CloseClients();

	void SendAllClients(const char* lpMessage);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	bool m_IsShown;
	bool m_IsCreated;

	long m_SockMode;
	CString m_PeerAddr;
	UINT m_PortNo;
	CString m_UserName;

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedConnectButton();
	afx_msg void OnBnClickedHelpButton();
	CButton m_ConnectBtnCtrl;
	CString m_RecvText;
	CString m_SendText;
	afx_msg void OnBnClickedSendButton();
	CButton m_SendBtnCtrl;
	CEdit m_SendEditCtrl;
	CEdit m_RecvEditCtrl;
};
