// ConnectionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "zChatClient.h"
#include "ConnectionDlg.h"


#include "..\plugin API\ExtAPI.h"
extern CExtAPI theAPI;

#include "..\plugin API\zFunc.h"
#include "..\plugin API\zVar.h"
#include "..\plugin API\zStr.h"
#include "..\plugin API\zList.h"
#include "..\plugin API\zBuffer.h"

// CConnectionDlg dialog

IMPLEMENT_DYNAMIC(CConnectionDlg, CDialog)
CConnectionDlg::CConnectionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectionDlg::IDD, pParent)
	, m_PeerAddr(_T(""))
	, m_PortNo(0)
	, m_UserName(_T(""))
{
	m_SockMode = 0;
}

CConnectionDlg::~CConnectionDlg()
{
}

void CConnectionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MODE_COMBO, m_ModeComboCtrl);
	DDX_Text(pDX, IDC_ADDR_EDIT, m_PeerAddr);
	DDX_Text(pDX, IDC_PORT_EDIT, m_PortNo);
	DDX_Text(pDX, IDC_NAME_EDIT, m_UserName);
	DDX_Control(pDX, IDC_ADDR_EDIT, m_AddrEditCtrl);
}


BEGIN_MESSAGE_MAP(CConnectionDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_MODE_COMBO, OnCbnSelchangeModeCombo)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CConnectionDlg message handlers

BOOL CConnectionDlg::OnInitDialog() {
	CDialog::OnInitDialog();

	// get icon
	CzFunc f;
	HICON hIcon;
	if(f.GetFunc("application.GetIcon")) {
		if(theAPI.var_GetValueEx(f.Execute(), VarID_LPVOID, &hIcon)) {
			SetIcon(hIcon, true);
		}
	}


	m_ModeComboCtrl.AddString("Guest");
	m_ModeComboCtrl.AddString("Host");
	m_ModeComboCtrl.SetCurSel(m_SockMode);

	FormatControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CConnectionDlg::OnCbnSelchangeModeCombo() {

	m_SockMode = m_ModeComboCtrl.GetCurSel();
	
	FormatControls();
}

void CConnectionDlg::FormatControls() {

	if(m_SockMode==0) { // client
		m_AddrEditCtrl.EnableWindow(true);
	} else
	if(m_SockMode==1) { // server
		m_AddrEditCtrl.EnableWindow(false);
	}
}
void CConnectionDlg::OnBnClickedOk() {

	UpdateData(TRUE);
	
	if(m_SockMode==0) { // client
		if(m_PortNo<=0 || m_PortNo>=65536) {
			AfxMessageBox("Please enter a valid port number.");
			return;
		}
		if(m_PeerAddr.GetLength()==0) {
			AfxMessageBox("Please enter a valid IP address.");
			return;
		}
	} else
	if(m_SockMode==1) { // server
		if(m_PortNo<=0 || m_PortNo>=65536) {
			AfxMessageBox("Please enter a valid port number.");
			return;
		}
	}

	OnOK();
}
