// zChatClient.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"

#include "zChatClient.h"

#include "..\plugin API\ExtAPI.h"
extern CExtAPI theAPI;

#include "..\plugin API\zFunc.h"
#include "..\plugin API\zVar.h"
#include "..\plugin API\zStr.h"
#include "..\plugin API\zList.h"
#include "..\plugin API\zBuffer.h"

#include "ChatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CzChatClientApp

BEGIN_MESSAGE_MAP(CzChatClientApp, CWinApp)
END_MESSAGE_MAP()


// CzChatClientApp construction

CzChatClientApp::CzChatClientApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CzChatClientApp object

CzChatClientApp theApp;


// CzChatClientApp initialization

BOOL CzChatClientApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}


bool __stdcall ExtInitPlugin(FARPROC pFunc, LPVOID hID) {

	if(!theAPI.InitAPI(pFunc, hID)) {
		AfxMessageBox("zChatClient::ExtInitPlugin error:\r\n - cannot load L3DT functions");
		return false;
	}

	CzFunc func;

	func.LoadFunc("ExtShowWnd", VarID_void, NULL);

	// add menu options
	theAPI.menu_InsertItemEx("ExtShowWnd", "Chat client", false);

	CzList args;
	
	// socket connect handler
	args.DelAll();
	args.CreateItem(VarID_LPVOID, "hSock");
	func.LoadFunc("ExtOnConnect", VarID_void, args.GetZVAR());

	// socket accept handler
	args.DelAll();
	args.CreateItem(VarID_LPVOID, "hSock");
	func.LoadFunc("ExtOnAccept", VarID_void, args.GetZVAR());

	//// socket recieve handler
	args.DelAll();
	args.CreateItem(VarID_LPVOID, "hSock");
	func.LoadFunc("ExtOnRecv", VarID_void, args.GetZVAR());

	// socket close handler
	args.DelAll();
	args.CreateItem(VarID_LPVOID, "hSock");
	func.LoadFunc("ExtOnClose", VarID_void, args.GetZVAR());
	
	return true;
}

bool __stdcall ExtShowWnd(ZVAR hReturnVar, ZLIST hArgList) {

	theApp.dlg.ShowWnd();
	
	return true;
}

bool __stdcall ExtOnConnect(ZVAR hReturnVar, ZLIST hArgList) {
	LPVOID hSock = NULL;
	if(!theAPI.var_GetValueEx(theAPI.list_GetItemI(hArgList, 0), VarID_LPVOID, &hSock)) {
		return false;
	}
	if(!hSock) {
		return false;
	}
	theApp.dlg.OnConnect(hSock);
	return true;
}
bool __stdcall ExtOnAccept(ZVAR hReturnVar, ZLIST hArgList) {
	LPVOID hSock = NULL;
	if(!theAPI.var_GetValueEx(theAPI.list_GetItemI(hArgList, 0), VarID_LPVOID, &hSock)) {
		return false;
	}
	if(!hSock) {
		return false;
	}
	theApp.dlg.OnAccept(hSock);
	return true;
}
bool __stdcall ExtOnRecv(ZVAR hReturnVar, ZLIST hArgList) {
	LPVOID hSock = NULL;
	if(!theAPI.var_GetValueEx(theAPI.list_GetItemI(hArgList, 0), VarID_LPVOID, &hSock)) {
		return false;
	}
	if(!hSock) {
		return false;
	}

	theApp.dlg.OnRecv(hSock);
	return true;
}
bool __stdcall ExtOnClose(ZVAR hReturnVar, ZLIST hArgList) {
	LPVOID hSock = NULL;
	if(!theAPI.var_GetValueEx(theAPI.list_GetItemI(hArgList, 0), VarID_LPVOID, &hSock)) {
		return false;
	}
	if(!hSock) {
		return false;
	}
	theApp.dlg.OnClose(hSock);
	return true;
}